const key_capslock%=20

global desk%[4] 'x y w h
getdesktoparea desk

extern
  function qreplace(out$,in%,pos%) 'speed up for readutf
endextern
extern "Win32"
  function SystemParametersInfoA%(action%,param%,param2:byte ptr,winini%)
  function GetTickCount%() 'millisecs
endextern

function getdesktoparea(lpRect%[]) 'x y w h
  SystemParametersInfoA(SPI_GETWORKAREA,0,lpRect,0)
endfunction

'-----------------------------------------

function loadgfont(f:tstream,fnt:tguifont var)
'  if not readbyte(f) then return
'  local fntname$=readstr(f)
'  local fntsize%=readpint(f)
'  local fntstyle%=readpint(f)
'  fnt=loadguifont(fntname,fntsize,fntstyle)
  fnt.name=readstr(f)
  fnt.size=readpint(f)
  fnt.style=readpint(f)
  fnt=loadguifont(fnt.name,fnt.size,fnt.style)
endfunction
function savegfont(f:tstream,fnt:tguifont)
'  local a%=(fnt<>null)
'  writebyte f,a
'  if not a then return
  writestr f,fnt.name
  writepint f,fnt.size
  writepint f,fnt.style
endfunction

function setlayout(g:tgadget,xw%,yh%,grp:tgadget,lft%=1,up%=1)
  local x2%,y2%
  if (xw=clientwidth (grp)) then x2=1
  if (yh=clientheight(grp)) then y2=1
'  if (xw=gadgetwidth (grp)) then x2=1
'  if (yh=gadgetheight(grp)) then y2=1
  setgadgetlayout g,lft,x2,up,y2
endfunction

function createlab:tgadget(name$,x%,y%,w%,h%,grp:tgadget,style%=0)
  local g:tgadget=createlabel(name,x,y,w,h,grp,style)
  setlayout g,x+w,y+h,grp
  return g
endfunction

const event_dropfile%=$4010
const event_dropdir%=$4011

function createwin:twin(name$,x%,y%,w%,h%,style%=15,grp:tgadget=null)
  local g:twin=new twin
  g.name=name
  g.x=x
  g.y=y
  g.w=w
  g.h=h
  g.maxsize
  g.outside
  g.hidden=(style&window_hidden>0)
  g.g=createwindow(name,x,y,w,h,grp,style)
'  if not(style&window_hidden) or (actwin=null) then actwin=g
'  g.client=(style&window_clientcoords<>0)
  g.cw=clientwidth (g.g)
  g.ch=clientheight(g.g)
'  g.cw=gadgetwidth (g.g)
'  g.ch=gadgetheight(g.g)
  return g
endfunction

function freewin(w:twin)
  freegadget w.g
endfunction

type twin
  field g:tgadget
  field kid:tgadget=null
  field name$
  field x%,y%,w%,h%
  field cw%,ch%
  field hidden%',client%',maximized%
  field drop$,droptyp%

  method load(f:tstream,wh%=true,dat%=false)
    x=readpint(f)
    y=readpint(f)
    if wh then
      w=readpint(f)
      h=readpint(f)
    endif
'    client=readbyte(f)
'    maxsize
    outside
    if not dat then return
    name=readstr(f)
    setgadgettext g,name
  endmethod
  method save(f:tstream,wh%=true,dat%=false)
    writepint f,x
    writepint f,y
    if wh then
      writepint f,w
      writepint f,h
    endif
'    writebyte f,client
    if not dat then return
    writestr f,name
  endmethod

  method setname(n$)
    name=n
    setgadgettext g,n
  endmethod

  method reset()
'    if client then setgadgetshape g,x+cclientwidth,y+cclientheight,w-cclientwidth,h-cclientheight..
'              else setgadgetshape g,x,y,w,h
    setgadgetshape g,x,y,w,h
    cw=clientwidth (g)
    ch=clientheight(g)
  endmethod

  method activate()
    if (kid=null) then activategadget g else activategadget kid
  endmethod

  method show()
    hidden=0
    showgadget g
    if (kid<>null) then activategadget kid
'    pollsystem
  endmethod
  method hide()
    hidden=1
    hidegadget g
    pollsystem
  endmethod

  method center()
    x=desk[0]+(desk[2]-w)/2
    y=desk[1]+(desk[3]-h)/2
  endmethod

  method maxsize()
    if (w>desk[2]) then w=desk[2]
    if (h>desk[3]) then h=desk[3]
  endmethod

  method outside()
    if (x+w<desk[0]+16) then x=desk[0]+16-w
    if (x>desk[2]-16)   then x=desk[2]-16
    if (y<desk[1]-10)   then y=desk[1]-10
    if (y>desk[3]-20)   then y=desk[3]-20
  endmethod

  method upd%() 'return currentevent.id
    if (currentevent.source<>g) then return 0
    select currentevent.id
    case event_windowmove
      x=currentevent.x
      y=currentevent.y
      cw=clientwidth (g)
      ch=clientheight(g)
    case event_windowsize
      w=currentevent.x
      h=currentevent.y
      cw=clientwidth (g)
      ch=clientheight(g)
'    case event_windowactivate
'      actwin=self
'      if (kid<>null) then activategadget kid
    case event_windowaccept
      drop=string(currentevent.extra)
      droptyp=filetype(drop)
      if (droptyp=filetype_file) then
        drop=delast(drop)
        return event_dropfile
      endif
      return event_dropdir
    endselect
    return currentevent.id
  endmethod
endtype

'-----------------------------------------

function createmenue:tmenu(title$="",grp:tgadget=null,tg%=0,dis%=0,hkey%=0,mods%=0)
  local m:tmenu=new tmenu
  m.flag=m.flag[..1]
  m.flag[0]=tg shl 1
  m.g=m.g[..1]
  m.grp=grp
  m.g[0]=createmenu(title,tg,grp,hkey,mods)
  if dis then disablemenu m.g[0]
  return m
endfunction

type tmenu
  field g:tgadget[]
  field grp:tgadget
  field sub%
  field flag%[] 'bit0=checkable bit1>=tag

  method load(f:tstream)
    repeat
      local fl%=readpint(f)
      if (fl=-1) then exit

      local fnd%=find(fl shr 1)
      if (fnd=-1) or (~flag[fnd]&$1) then
        f.skipbytes 1
      else
        flag[fnd]=(flag[fnd]&$fffffffe)|(fl&1)
        local b@=readbyte(f)
        if (b&$1) then checkmenu  g[fnd] else uncheckmenu g[fnd]
        if (b&$2) then enablemenu g[fnd] else disablemenu g[fnd]
      endif
    forever
    if (grp<>null) then updatewindowmenu grp
  endmethod
  method save(f:tstream)
    for local a%=0 until flag.length
      if (flag[a]&$1) then
        writepint f,flag[a]
        writebyte f,menuchecked(g[a])+menuenabled(g[a]) shl 1
      endif
    next
    writepint f,-1
  endmethod

'flg bit0=checkable bit1=checked bit2=disabled
  method create(text$="",grp2:tgadget=null,tg%=0,flg%=0,hkey%=0,mods%=0)
    if not grp2 then grp2=grp
    sub=g.length
    g=g[..g.length+1]
    g[g.length-1]=createmenu(text,tg,windowmenu(grp2),hkey,mods)
    if (flg&2) then checkmenu   g[g.length-1]
    if (flg&4) then disablemenu g[g.length-1]
    flag=flag[..flag.length+1]
    flag[flag.length-1]=(flg&1)+(tg shl 1)
  endmethod

'flg bit0=checkable bit1=checked bit2=disabled
  method add(text$,tg%=0,flg%=0,hkey%=0,mods%=0)
    g=g[..g.length+1]
    g[g.length-1]=createmenu(text,tg,g[sub],hkey,mods)
    if (flg&2) then checkmenu   g[g.length-1]
    if (flg&4) then disablemenu g[g.length-1]
    flag=flag[..flag.length+1]
    flag[flag.length-1]=(flg&1)+(tg shl 1)
  endmethod

  method endadd()
    if (grp<>null) then updatewindowmenu grp
  endmethod

  method gettext$(tg%)
    for local a%=0 until flag.length
      if (tg=flag[a] shr 1) then return menutext(g[a])
    next
  endmethod

  method get%(tg%) 'return bit0=checked bit1=disabled
    for local a%=0 until flag.length
      if (tg=flag[a] shr 1) then return menuchecked(g[a])+((1-menuenabled(g[a])) shl 1)
    next
  endmethod
'flg bit0=checked bit1=disabled
  method set(tg%,flg%)
    for local a%=0 until flag.length
      if (tg=flag[a] shr 1) then
        if (flg&1) then checkmenu   g[a] else uncheckmenu g[a]
        if (flg&2) then disablemenu g[a] else enablemenu  g[a]
        if (grp<>null) then updatewindowmenu grp
      endif
    next
  endmethod

  method popup(tg%,where:tgadget=null)
    if (where=null) then where=grp
    popupwindowmenu where,g[max(find(tg),0)]
  endmethod

  method find%(tg%) 'return nr or -1
    for local a%=0 until flag.length
      if (tg=flag[a] shr 1) then return a
    next
    return -1
  endmethod

  method upd%() '?same tags same check, return tag
    if (currentevent.id<>event_menuaction) then return 0
    for local a%=0 until flag.length
'if (currentevent.source=g[a]) then
      if (currentevent.data=flag[a] shr 1) then
        if (flag[a]&1) then
          if menuchecked(g[a]) then uncheckmenu g[a] else checkmenu g[a]
          if (grp<>null) then updatewindowmenu grp
        endif
        return currentevent.data
      endif
    next
  endmethod
endtype

'-----------------------------------------

type tbut
  field g:tgadget[]
  field flag%[] 'bit0=checkbox bit1=disabled bit2>=tag

  method load(f:tstream)
    for local a%=0 until readpint(f)
      local flg%=readpint(f)
      for local b%=0 until g.length
        if (flg shr 2=flag[b] shr 2) then setbuttonstate g[b],flg&1
      next
    next
  endmethod
  method save(f:tstream)
    local l%
    for local a%=0 until g.length
      if (flag[a]&1) then l:+1
    next
    writepint f,l
    for local a%=0 until g.length
      if (flag[a]&1) then writepint f,buttonstate(g[a])+(flag[a]&$fffffffc)
    next
  endmethod

  method add(label$,tg%,x%,y%,w%,h%,grp:tgadget,sel%=0,style%=button_push,disable%=false)
    g=g[..g.length+1]
    g[g.length-1]=createbutton(label,x,y,w,h,grp,style)
    setlayout g[g.length-1],x+w,y+h,grp
    if sel then setbuttonstate g[g.length-1],1
    flag=flag[..flag.length+1]
    flag[flag.length-1]=((style=button_checkbox) or (style=button_radio))+(disable shl 1)+(tg shl 2)
    if disable then disablegadget g[g.length-1]
  endmethod

  method get%(tg%)
    for local a%=0 until g.length
      if (tg=flag[a] shr 2) then return buttonstate(g[a])
    next
  endmethod
  method set(tg%,sel%)
    for local a%=0 until g.length
      if (tg=flag[a] shr 2) then
        setbuttonstate g[a],sel
        return
      endif
    next
  endmethod

  method find%(tg%)
    for local a%=0 until g.length
      if (tg=flag[a] shr 2) then return a
    next
  endmethod

  method upd%() 'return tag
    if (currentevent.id<>event_gadgetaction) then return 0
    for local a%=0 until g.length
      if (currentevent.source=g[a]) then return flag[a] shr 2
    next
  endmethod
endtype

'-----------------------------------------

function createboxlist:tboxlist(x%,y%,w%,h%,grp:tgadget)
  local b:tboxlist=new tboxlist
  b.g=createlistbox(x,y,w,h,grp)
  setlayout b.g,x+w,y+h,grp
  return b
endfunction

type tboxlist
  field g:tgadget
  field on%,count%

  method load(f:tstream,dat%=false)
    on=readpint(f)
    if dat then
      cleargadgetitems g
      count=readpint(f)
      for local a%=0 until count
        addgadgetitem g,readstr(f)
      next
    endif
    if not count then return
    if (on>=count) then on=count-1
    selectgadgetitem g,on
  endmethod

  method save(f:tstream,dat%=false)
    writepint f,on
    if not dat then return

    writepint f,count

    for local a%=0 until count
      writestr f,gadgetitemtext(g,a)
    next
  endmethod

  method clear()
    on=0
    count=0
    cleargadgetitems g
  endmethod

  method add(text$,tip$="",icon%=-1,extra:object=null)
    addgadgetitem g,text,0,icon,tip,extra
    count:+1
  endmethod

'return currentevent.id  (event_gadgetaction,event_gadgetselect)
  method upd%()
    if (currentevent.source<>g) then return 0
'    if (currentevent.data<0) then return 0
    select currentevent.id
    case event_gadgetaction,event_gadgetselect,event_gadgetmenu
    default
      return 0
    endselect
'    if (on=currentevent.data) then return 2
if currentevent.data=-1 then return 0
    on=currentevent.data
    return currentevent.id
  endmethod
endtype

'-----------------------------------------

'style=$1=textfield_password $2=disable
function createfeld:tfeld(text$,x%,y%,w%,h%,grp:tgadget,style%=0)
  local f:tfeld=new tfeld
  f.g=createtextfield(x,y,w,h,grp,style&1)
  setgadgetcolor f.g,0,0,0
  setgadgettextcolor f.g,255,255,255
  setlayout f.g,x+w,y+h,grp
  setgadgettext f.g,text
  return f
endfunction

type tfeld
  field g:tgadget

  method load(f:tstream)
    setgadgettext g,readutf(f)
  endmethod
  method save(f:tstream)
    writeutf f,textfieldtext(g)
  endmethod

  method get$()
    return textfieldtext(g)
  endmethod
  method set(s$)
    setgadgettext g,s
  endmethod

  method upd%()
    if (currentevent.id<>event_gadgetaction)..
    or (currentevent.source<>g) then return 0
    return 1
  endmethod
endtype

'-----------------------------------------

function createtext:ttext(x%,y%,w%,h%,grp:tgadget,style%=0)
  local t:ttext=new ttext
  t.flag=(style=textarea_readonly) shl 1
  t.g=createtextarea(x,y,w,h,grp,style)
  setlayout t.g,x+w,y+h,grp
'  setgadgetfilter t.g,textfilter
  settextareacolor t.g,0,0,0,true
  settextareacolor t.g,255,255,255,false
'  formattextareatext t.g,255,255,255,0
  t.settabs 3
  return t
endfunction

'select ttext.upd
'  case 1 tmenu.popup 0,win.g
'  case 2 ttext.updkey
type ttext
  field g:tgadget
  field tab%,flag% '$1=linesafe $2=readonly $4=insertmode
  field chars%,lines%
  field char%,line%,linestart%,lineend%,inline%
  field selchars%,sellines%
field lastcol%[3]'=[-1,-1,-1]
field lt$

  method load(f:tstream,data%=false)
    tab=readbyte(f)
    flag=readbyte(f)
    if not data then return
    settextareatext g,readutf(f)
'    settextareatext g,readstr(f)
    selecttextareatext g,readpint(f),readpint(f)
    updpos
  endmethod
  method save(f:tstream,data%=false)
    writebyte f,tab
    writebyte f,flag
    if not data then return
    writeutf f,textareatext(g)
'    writestr f,textareatext(g)
    writepint f,selchars
    writepint f,char
  endmethod

'  method loadtxt(f:tstream,ln%=-1)
'    while ln and not eof(f)
'      addtextareatext g,readline(f)
''      addtextareatext g,readutf2(f)+"~n"
'      ln:-1
'    wend
'    updpos
'  endmethod

  method importtxt(f:tstream,insrt%=false)
    local t$
    if isheader(f,chr($ff)+chr($fe)) then
      t=readutf2(f)
    else
      f.seek 0
      t=readstring(f,f.size()-f.pos())
    endif
    t=convertstr(t,chr(13)+"~n","~n")
    if insrt then
      insert t
    else
      settextareatext g,t
      updpos
    endif
  endmethod
  method exporttxt(f:tstream)
    local t$=textareatext(g)
    t=convertstr(t,"~n",chr(13)+"~n")
    for local a%=0 until t.length
      if (t[a]>255) then
        writeshort f,$feff
        writeutf2 f,t
        return
      endif
    next
    writestring f,t
  endmethod

  method settabs(sz%)
    tab=sz
    settextareatabs g,sz
  endmethod

  method lock(hid%=0)
    locktextarea g
    showmouse
    if hid then hidegadget g
  endmethod
  method unlock(shw%=0)
    unlocktextarea g
    if shw then showgadget g
  endmethod

  method setfont(fnt:tguifont,locked%=true)
'    updpos
'    if not fnt then return
    if locked then lock
    local t$=textareatext(g)
    settextareatext g,""
    settextareafont g,fnt
    settextareatext g,t
    if locked then unlock
    selecttextareatext g,char,selchars
  endmethod

  method searchr%(s$,sl%=true,loop%=true)
'    s=lower(s)
    if (selchars=s.length) and (lower(textareatext(g,char,selchars))=s) then char:+s.length
    local p%=instr(lower(textareatext(g,char)),s)
    if not p then
      if not loop then return 0
      p=instr(lower(textareatext(g,0,char+s.length-1)),s)
      if not p then return 0
      char=0
    endif
    char:+p-1
    selchars=s.length
    if sl then selecttextareatext g,char,selchars
    return 1
  endmethod
  method searchl%(s$,sl%=true)
'    s=lower(s)
    local p%=instrl(lower(textareatext(g,0,char+s.length-1)),s)
    if not p then
      p=instrl(lower(textareatext(g,char)),s)
      if not p then return 0
      char:+p-1
    else
      char=p-1
    endif
    selchars=s.length
    if sl then selecttextareatext g,char,selchars
    return 1
  endmethod

  method getselorline$()
    if selchars then return textareatext(g,char,selchars)
    return delast(textareatext(g,line,1,textarea_lines),10)
  endmethod

  method getline$(l%=-1)
    if (l<0) then l=line
    return delast(textareatext(g,l,1,textarea_lines),10)
  endmethod

  method set(t$)
    settextareatext g,t
    updpos
  endmethod
  method insert(t$,sel0%=false)
    settextareatext g,t,char,selchars
    if sel0 then
      selecttextareatext g,char,t.length
    else
      selecttextareatext g,char+t.length,0
    endif
    updpos
  endmethod

  method add2start()
    lt=""
    lastcol=[-1,-1,-1]
  endmethod
  method add2(t$,col%[])
    if (col[0]<>lastcol[0]) or (col[1]<>lastcol[1]) or (col[2]<>lastcol[2]) then
      addtextareatext g,lt
      formattextareatext g,lastcol[0],lastcol[1],lastcol[2],0,textarealen(g)-lt.length,lt.length
      lastcol[0]=col[0]
      lastcol[1]=col[1]
      lastcol[2]=col[2]
      lt=""
    endif
    lt:+t
  endmethod
  method add2snapshot()
    addtextareatext g,lt
    formattextareatext g,lastcol[0],lastcol[1],lastcol[2],0,textarealen(g)-lt.length,lt.length
    lt=""
  endmethod
  method add2end()
    addtextareatext g,lt
    formattextareatext g,lastcol[0],lastcol[1],lastcol[2],0,textarealen(g)-lt.length,lt.length
    lt=""
    updpos
  endmethod

  method copypos(from:ttext)
    lineend=textareachar(g,from.line+1)'-(line<lines-1)
    char=min(lineend-(chars>lineend),textareachar(g,from.line)+from.inline)

    selchars=textareachar(g,from.line+from.sellines)-textareachar(g,from.line)..
     +min(textareachar(g,textarealine(g,char+selchars)+1)-textareachar(g,textarealine(g,char+selchars))..
         ,from.linestart+from.selchars-textareachar(from.g,textarealine(from.g,from.char+from.selchars)))

    selecttextareatext g,char,selchars
'    selecttextareatext g,char,min(lineend-char,from.selchars)
    updpos
  endmethod

  method updpos()
    local olines%=lines+(lines=0),oline%=line
    local a%
    repeat
      chars=textarealen(g)
      lines=textarealen(g,textarea_lines)+(chars>0)

      char=textareacursor(g)
      line=textareacursor(g,textarea_lines)
      linestart=textareachar(g,line)
      lineend=textareachar(g,line+1)'-(line<lines-1)
      inline=char-linestart

      selchars=textareasellen(g)
'      sellines=textareasellen(g,textarea_lines)-(inline<>0)*(selchars=0)
      sellines=textarealine(g,char+selchars)-line

      if not(flag&$1) or (lines=olines) or a then return
      a:+1
      locktextarea g
      if (lines>olines) then
        if (flag&$4) then
'          settextareatext g,"",textareachar(g,oline+1)-(oline=olines-1),textareachar(g,oline+1+lines-olines)-textareachar(g,oline+1)+(oline=olines-1)
          local lo%=lines-olines
          local olo%=oline+lo
          settextareatext g,"",textareachar(g,olo),textareachar(g,olo+lo)-textareachar(g,olo)
          settextareatext g,"",textareachar(g,olines)-(olines<textarealen(g,textarea_lines))
        else
          settextareatext g,"",textareachar(g,olines)-1
        endif
      else
        addtextareatext g,charmul(chr(10),olines-lines)
      endif
      unlocktextarea g
      selecttextareatext g,char,0
    forever
  endmethod

  method upd%() 'return 1=gadgetmenu, 2=active
    if (currentevent.source<>g) then return 0
    select currentevent.id
    case event_gadgetmenu  return 1
    case event_gadgetselect  updpos
    case event_gadgetlostfocus  return 0
    endselect
    return 2
  endmethod

  method updkey%()
    select currentevent.id
    case event_keydown
      select currentevent.data
      case key_insert  flag:~$4
      endselect

    case event_keychar
      settextareatext g,chr(currentevent.data),char,selchars+(flag&$4<>0)
      selecttextareatext g,char+1,0
      updpos
      return true
    endselect
  endmethod

ifdef debug
  method pos2str$()
    return "chs:"+chars+" lns:"+lines..
     +" ch:"+char+" ln:"+line+" ls:"+linestart+" le:"+lineend+" inl:"+inline..
     +" selchs:"+selchars+" sellns:"+sellines
  endmethod
elsedef
  method pos2str$()
    return "Line:"+pointed(line)+", Pos:"+pointed(char)+", Chars:"+pointed(chars)+", Lines:"+pointed(lines)
  endmethod
enddef
endtype

'-----------------------------------------

'rem
'tdir.reset "path",false
'while tdir.flag&$1
' if tdir.flags&$4 then d.skipdir
' print tdir.path+tdir.dir[0]+tdir.this
' if tdir.flags&$2 then dir
' tdir.upd
'wend
'tdir.close
type tdir
'public
  field path$
  field this$,dir$[] 'only 0 is important
'  field size%,files%,dirs%
  field flag% '$1=running $2=dir $4=dirchanged $8=sortdir
'private
  field rd%

'public
  method reset(p$,sortdir%=false)
    path=p
    dir=dir[..1]
    dir[0]=""
'    files=0
'    dirs=0
    rd=readdir(p)
    flag=(rd<>0)+sortdir shl 3
    if (flag&1) then upd
  endmethod

  method close()
    if (flag&1) then
      flag:&~1
      dir=dir[..0]
      closedir rd
    endif
  endmethod

  method skipdir%()
    closedir rd
    dir=dir[1..]
    if (dir.length=0) then
      flag:&~1
      return true
    endif
    if (flag&8) then dir.sort
    rd=readdir(path+dir[0])
    if not rd then
      dir=dir[..0]
      flag:&~1
      return true
    endif
    flag:|4
  endmethod

  method upd()
'    if not(flag&$1) then return
    flag:&~(2+4)
    repeat
      repeat
        this=nextfile(rd)
      until (this<>".") and (this<>"..")

      if (this="") then
        if skipdir() then return
      else
        if (filetype(path+dir[0]+this)=filetype_dir) then
          flag:|2
          dir=dir[..dir.length+1]
          dir[dir.length-1]=dir[0]+this+"\"
'          dirs:+1
'        else
'          size=filesize(path+dir[0]+this)
'          files:+1
        endif
        return
      endif
    forever
  endmethod
endtype

'-----------------------------------------

function addslash$(src$,sl%=asc"\")
  if src.length and (src[src.length-1]<>sl) then return src+chr(sl)
  return src
endfunction

'c:\path1.a\path2.b\file.test = file
function trimname$(src$,hidext%=false)
  local sl1%=src.length
  local sl2%=sl1
  local l%=true
  while (sl1>0)
    sl1:-1
    if (l or hidext) and (src[sl1]=asc".") then
      sl2=sl1
      l=false
    endif
    if (src[sl1]=asc"\") then return src[sl1+1..sl2]
  wend
  return src[sl1..sl2]
endfunction

'c:\path1.a\path2.b\file.test = file.test
function trimfile$(src$)
  local sl%=src.length
  while (sl>0)
    sl:-1
    if (src[sl]=asc"\") then return src[sl+1..]
  wend
  return src
endfunction

'c:\path1.a\path2.b\file.test = test
function trimext$(src$)
  local sl%=src.length
  while (sl>0)
    sl:-1
    if (src[sl]=asc".") then return src[sl+1..]
    if (src[sl]=asc"\") then return ""
  wend
endfunction

'c:\path1.a\path2.b\file.test = c:\path1.a\path2.b\file
function trimpname$(src$,hidext%=false)
  local sl%=src.length
  local sl2%=src.length
  local l%=true
  while (sl>0)
    sl:-1
    if (src[sl]=asc"\") then return src[..sl2]
'    if (src[sl]=asc".") then return src[..sl]
    if (l or hidext) and (src[sl]=asc".") then
      sl2=sl
      l=false
    endif
  wend
  return src[..sl2]
endfunction

'-----------------------------------------

function readcomment$(f:tstream,linecom%=asc";")
  local t$
  while not eof(f)
    t=readline(f)
    if not t then return t
    local a%
    while (a<t.length)
      if (t[a]<>asc" ") then exit
      a:+1
    wend
    if (a<t.length) and (t[a]=linecom) then continue
    return t
  wend
endfunction

function gotohead%(f:tstream,what$,seek0%=true)
  if seek0 then f.seek 0
  what=lower(what)
  while not eof(f)
    local t$=deleast(readcomment(f))
    if t and (t[0]=asc"[") and (t[t.length-1]=asc"]")..
    and (lower(deleast(delchars(t,"[]")))=what) then return true
'    and (lower(deleast(t[1..t.length-2]))=what) then return true
  wend
endfunction
function isheader%(f:tstream,h$)
  local ret$
  while not eof(f) and (ret.length<h.length)
    ret:+chr(readbyte(f))
  wend
  return (ret=h)
endfunction

function readstr$(f:tstream)
  return readstring(f,readpint(f))
endfunction
function writestr(f:tstream,s$)
  writepint f,s.length
  writestring f,s
endfunction

function readpint%(f:tstream)
  local ret%,a%,c%
  repeat
    a=readbyte(f)
    ret:+(a&$7f) shl c
    c:+7
  until not(a&$80)
  return ret
endfunction
function writepint(f:tstream,src%)
  repeat
    writebyte f,(src&$7f) + ((src shr 7<>0) shl 7)
    src:shr 7
  until not src
endfunction

function writeutf(f:tstream,src$)
  writepint f,src.length
  for local a%=0 until src.length
    writepint f,src[a]
  next
endfunction
function readutf$(f:tstream)
  local ln%=readpint(f)
  local ret$=charmul(" ",ln)
  for local a%=0 until ln
'    ret:+chr(readpint(f)) 'slow as john doe
    qreplace ret,readpint(f),a
  next
  return ret
endfunction

function writeutf2(f:tstream,src$)
  for local a%=0 until src.length
    writeshort f,src[a]
  next
endfunction
function readutf2$(f:tstream)
  local sz%=(f.size()-f.pos()) shr 1
  local ret$=charmul(" ",sz)
  for local a%=0 until sz
'    ret:+chr(readbyte(f)+readbyte(f) shl 8) 'slow as john doe
    qreplace ret,readshort(f),a
  next
  return ret
endfunction

'-----------------------------------------

function convertstr$(src$,ch1$,ch2$)
  local cl1%=ch1.length
  if (cl1=0) then return src
  local pos%=src.length
  pos:-cl1
  while (pos>=0)
'    if (lower(src[pos..pos+cl1])=ch1) then src=src[..pos]+ch2+src[pos+cl1..]
    local b%
    while (b<cl1)
      if (src[pos+b]<>ch1[b]) then exit
      b:+1
    wend
    if (b=cl1) then src=src[..pos]+ch2+src[pos+cl1..]
    pos:-1
  wend
  return src
endfunction

function delead$(src$,ch%=asc" ")
  local a%,sl%=src.length
  while (a<sl) and (src[a]=ch)
    a:+1
  wend
  return src[a..]
endfunction

function delast$(src$,ch%=asc"\")
  local sl%=src.length-1
  while (sl>=0) and (src[sl]=ch)
    sl:-1
  wend
  return src[..sl+1]
endfunction

function deleast$(src$,ch%=asc" ")
  local a%,sl%=src.length
  while (a<sl) and (src[a]=ch)
    a:+1
  wend

  sl:-1
  while (sl>=0) and (src[sl]=ch)
    sl:-1
  wend
  return src[a..sl+1]
endfunction

function delchars$(src$,ch$="\/:*?<>|"+chr(34))
  local sl%=src.length,cl%=ch.length-1
  while (sl>0)
    sl:-1
    local a%=cl,sc%=src[sl]
    while (a>=0)
      if (sc=ch[a]) then exit
      a:-1
    wend
    if (a>=0) then src=src[..sl]+src[sl+1..]
  wend
  return src
endfunction

'cocktailsort
function sortstr(arr$[],p1%,p2%) 'p2=last entry(length-1)
  while (p1<p2-1)
    local ok%
    local v$=arr[p1]
    local vl$=lower(v)
    local ps%=p1
    for local a%=p1+1 to p2
      local al$=lower(arr[a])
      if (al<vl) then
        v=arr[a]
        vl=lower(v)
        ps=a
        ok=true
      endif
    next
    if ok then
      arr[ps]=arr[p1]
      arr[p1]=v
    endif
    p1:+1

    ok=false
    v=arr[p2]
    vl=lower(v)
    ps=p2
    for local a%=p2-1 to p1 step-1
      local al$=lower(arr[a])
      if (al>vl) then
        v=arr[a]
        vl=lower(v)
        ps=a
        ok=true
      endif
    next
'    if not ok then return
if ok then
    arr[ps]=arr[p2]
    arr[p2]=v
endif
    p2:-1
  wend
endfunction

function instrl%(src$,ch$,pos%=0)
  local cl%=ch.length
  if (cl=0) then return 0
  if (pos=0) then pos=src.length
  pos:-cl
  while (pos>=0)
    local p%
    while (p<cl)
      if (src[pos+p]<>ch[p]) then exit
      p:+1
    wend
    if (p=cl) then return pos+1
    pos:-1
  wend
endfunction

function charmul$(ch$,mul%)
  if not mul then return ""
  local a%=1
  while (a+a<mul)
    ch:+ch
    a:+a
  wend
  return ch+ch[..mul-a]
endfunction

function float2str$(src#,commalen%=3)
  local ret$=src
  local p%=instr(ret,".")
  if (p>0) then return ret[..p+commalen-(commalen=0)]
  return ret
endfunction

function pointed$(src$,ch$=".",inter%=3)
  local p%=src.length
  repeat
    p:-inter
    if (p>0) then src=src[..p]+ch+src[p..] else return src
  forever
endfunction
